//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
BOOL TForm1::LoadPdfToTiffDll()
{
	m_hinstLib = LoadLibrary("pdftotiff.dll");
	if( m_hinstLib != NULL ){ 
		pLoad = (MLoad *)GetProcAddress(m_hinstLib, "MLoad");
		if( pLoad == NULL ){ 
			FreePdfToTiffDll(); 
			return FALSE;
		}
		pEncode = (MEncode *)GetProcAddress(m_hinstLib, "MEncode");
		if( pEncode == NULL ){
			FreePdfToTiffDll();
			return FALSE;
		}
		pFree = (MFree *)GetProcAddress(m_hinstLib, "MFree");
		if( pFree == NULL ){
			FreePdfToTiffDll();
			return FALSE;
		}
		pGetCount = (MGetCount *)GetProcAddress(m_hinstLib, "MGetCount");
		if( pGetCount == NULL ){
			FreePdfToTiffDll();
			return FALSE;
		}
		pSetParam = (MSetParam *)GetProcAddress(m_hinstLib, "MSetParam");
		if( pSetParam == NULL ){ 
			FreePdfToTiffDll(); 
			return FALSE;
		}
	}
	return TRUE;
}
/////////////////////////////////////////////////////////////////////////////
BOOL TForm1::FreePdfToTiffDll()
{
    if( m_hinstLib ){
        FreeLibrary(m_hinstLib);
	}
	return TRUE;
}
void __fastcall TForm1::Button1Click(TObject *Sender)
{
	if( LoadPdfToTiffDll() == FALSE ){
        ShowMessage("Load pdftotiff.dll failed!");
		return;
	}

	long id = pLoad("test.pdf",NULL);
	if(id==-1){
        ShowMessage("PDF file unexist or damaged!");
		FreePdfToTiffDll();
		return;
	}
	if(id==-2){
        ShowMessage("PDF file is restricted!");
		FreePdfToTiffDll();
		return;
	}

	//The 1 is generate a multi-page TIFF file, the 0 is generate a TIFF file for each page
	long multipages = 1;
	pSetParam(id,"",IMAGE_FORMAT_TIF,24,COMPRESSION_LZW,0,0,multipages,0,0,0,96,96);

	long pageCount = pGetCount(id);
	for(long i=1; i<=pageCount; i++){
		pEncode(id,i);
		ProgressBar1->Position = i*100/pageCount;
	}
	pFree(id);

	FreePdfToTiffDll();
    ShowMessage("Convert finished!");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
	if( LoadPdfToTiffDll() == FALSE ){
        ShowMessage("Load pdftotiff.dll failed");
		return;
	}

	long id = pLoad("test.pdf",NULL);	
	if(id==-1){
        ShowMessage("PDF file unexist or damaged!");
		FreePdfToTiffDll();
		return;
	}
	if(id==-2){
        ShowMessage("PDF file is restricted!");
		FreePdfToTiffDll();
		return;
	}

	//The 1 is generate a multi-page TIFF file, the 0 is generate a TIFF file for each page
	long multipages = 0;
	pSetParam(id,"",IMAGE_FORMAT_TIF,8,COMPRESSION_JPEG,75,0,multipages,90,800,600,120,120);

	long pageCount = pGetCount(id);
	for(long i=1; i<=pageCount; i++){
		pEncode(id,i);
		ProgressBar1->Position = i*100/pageCount;
	}
	pFree(id);

	FreePdfToTiffDll();
    ShowMessage("Convert finished!");
}
//---------------------------------------------------------------------------
